<?php
/*
  Plugin Name: UmbigoThis
  Plugin URI: http://techlive.org/
  Description: Plugin social para Wordpress
  Author: Lenon Marcel
  Version: 0.1
  Author URI: http://techlive.org/
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

add_action('the_content', 'umb_content');
add_action('wp_head', 'umb_head');
add_action('admin_menu', 'umb_menu');
register_activation_hook(__FILE__, 'umb_install');
register_deactivation_hook(__FILE__, 'umb_uninstall');

$urls = umb_get();

function umb_addurl($url, $nome, $target, $icone){
	global $wpdb;
	if (!empty($url)):
		$tabela = $wpdb->prefix."umbigothis";
		$wpdb->query("INSERT INTO {$tabela} (id, nome, url, target, icone) VALUES ('','{$nome}','{$url}','{$target}', '{$icone}')");
		return true;
	else:
		return false;
	endif;
}

function umb_search($id) {
	global $wpdb;
	$tabela = $wpdb->prefix."umbigothis";
	if (!empty($id)):
		$nm = $wpdb->get_var("SELECT nome FROM {$tabela} WHERE id = {$id}");
		$url = $wpdb->get_var("SELECT url FROM {$tabela} WHERE id = {$id}");
		return array($nm, $url);
	endif;
}

function umb_get(){
	global $wpdb;
	$tabela = $wpdb->prefix."umbigothis";
	$resultados = $wpdb->get_results("SELECT * FROM {$tabela}");
	return $resultados;
}

function umb_del($id){
	global $wpdb;
	$tabela = $wpdb->prefix."umbigothis";
	$wpdb->query("DELETE FROM {$tabela} WHERE id = {$id}");
	return "<div class='updated'><p><strong>Site removido</strong></p></div>";
}

function umb_onclick() {
	return "onclick='umbigo();return false;'";
}

function umb_content($content) {
	global $urls;
	$post_url = urlencode(get_permalink($post->ID));

	if (!is_page() && !is_feed() && is_single()) {
		$content .= "
<div id='umbigoThis'>
	<a href='#' " . umb_onclick() . " rel='nofollow' class='social-link'>" . get_option('umb_txtexibicao') . "</a>
	<div class='compartilhe-links'>
		<p class='fechar'>
			<a href='#' " . umb_onclick() . " rel='nofollow' class='fechar-link'>Fechar</a>
			<span class='desc'>Compartilhe este post!</span>
		</p>
		<br clear='all'/>
		<div class='umb_links'>";
		foreach ($urls as $dados) {
			$nome = str_replace(' ', '', $dados->nome);
			$nome = eregi_replace("([^a-z])","",$nome);
			$content .= "<a class='comp-link comp-link-{$nome}' href='" . str_replace(array("{url}","{title}"), array($post_url, urlencode(get_the_title())), $dados->url) . "' rel='nofollow' target='" . $dados->target . "'>" . $dados->nome . "</a></li>";
		};
		$content .= "<br clear='all'/></div></div></div>";
	};
	return $content;
}

function umb_head() {
	global $urls;
	$cssurl = get_bloginfo('wpurl') . "/wp-content/plugins/umbigothis/umb.php?imp=estilo";
	$jsurl = get_bloginfo('wpurl') . "/wp-content/plugins/umbigothis/umb.php?imp=script";
	if (get_option('umb_autojquery') == 'true'):
		echo "<script type='text/javascript' src='" . get_bloginfo('wpurl') . "/wp-content/plugins/umbigothis/jquery.js'></script>";
	endif;
	print('<link rel="stylesheet" type="text/css" href="'. $cssurl .'" />');
	print('<script type="text/javascript" src="'. $jsurl .'" ></script>');
	print('<style type="text/css">');
	foreach ($urls as $dados) {
				$nome = str_replace(' ', '', $dados->nome);
				$nome = eregi_replace("([^a-z])","",$nome);
				print('.comp-link-' . $nome . '{background: url(' . get_bloginfo('wpurl') . '/wp-content/plugins/umbigothis/' . $dados->icone . ') left no-repeat;padding-left:18px;}');
			}
	print('</style>');
}

function umb_install(){
	global $wpdb;

	$social = array(
				array('diHitt', 'http://dihitt.com.br/submit.php?url={url}&titulo={title}', 'dihitt.gif'),
				array('B!Links', 'http://blinks.blogueisso.com/node/add/drigg?url={url}&title={title}', 'blinks.gif'),
				array('Ueba', 'http://ueba.com.br/NovoLink?url={url}&title={title}', 'ueba.gif'),
				array('Linkk', 'http://www.linkk.com.br/submit.php?url={url}', 'linkk.gif'),
				array('Rec6', 'http://rec6.via6.com/link.php?url={url}&titulo={title}', 'rec6.gif'),
				array('LinkTo', 'http://www.linkto.com.br/site.enviaNoticia.php?title={title}&url={url}', 'linkto.gif'),
				array('Eu Curti', 'http://www.eucurti.com.br/submit.php?url={url}', 'eucurti.gif'),
				array('Do Melhor', 'http://www.domelhor.net/submit.php?url={url}', 'domelhor.gif'),
				array('Ouvi Dizer', 'http://www.ouvidizer.com/submit.php?url={url}', 'ouvidizer.gif'),
				array('Link Loko', 'http://www.linkloko.com.br/submit.php?url={url}', 'linkloko.gif'),
				array('del.icio.us', 'http://del.icio.us/post?url={url}&title={title}', 'delicious.gif'),
				array('Digg', 'http://digg.com/submit?phase=2&url={url}&title={title}', 'digg.gif'),
				array('Furl', 'http://furl.net/storeIt.jsp?u={url}&t={title}', 'furl.gif'),
				array('Netscape', 'http://www.netscape.com/submit/?U={url}&T={title}', 'netscape.gif'),
				array('Yahoo! My Web', 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u={url}&t={title}', 'yahoo_myweb.gif'),
				array('StumbleUpon', 'http://www.stumbleupon.com/submit?url={url}&title={title}', 'stumbleupon.gif'),
				array('Google Bookmarks', 'http://www.google.com/bookmarks/mark?op=edit&bkmk={url}&title={title}', 'google_bmarks.gif'),
				array('Technorati', 'http://www.technorati.com/faves?add={url}', 'technorati.gif'),
				array('BlinkList', 'http://blinklist.com/index.php?Action=Blink/addblink.php&Url={url}&Title={title}', 'blinklist.gif'),
				array('Newsvine', 'http://www.newsvine.com/_wine/save?u={url}&h={title}', 'newsvine.gif'),
				array('ma.gnolia', 'http://ma.gnolia.com/bookmarklet/add?url={url}&title={title}', 'magnolia.gif'),
				array('reddit', 'http://reddit.com/submit?url={url}&title={title}', 'reddit.gif'),
				array('Windows Live', 'https://favorites.live.com/quickadd.aspx?marklet=1&mkt=en-us&url={url}&title={title}&top=1', 'windows_live.gif'),
				array('Tailrank', 'http://tailrank.com/share/?link_href={url}&title={title}', 'tailrank.gif'),
				array('Meneame', 'http://www.meneame.net/submit.php?url={url}', 'meneame.gif')
				);
	$tabela = $wpdb->prefix."umbigothis";

	$estrutura = "CREATE TABLE $tabela (
		id INT(9) NOT NULL AUTO_INCREMENT,
		nome VARCHAR(255) NOT NULL,
		url VARCHAR(255) NOT NULL,
		target VARCHAR(100) NOT NULL,
		icone VARCHAR(200) NOT NULL,
		UNIQUE KEY id (id)
	);";

	if($wpdb->get_var("SHOW TABLES LIKE '$tabela'") != $tabela) {
		$wpdb->query($estrutura);
	}

	foreach ($social as $ss => $ff) {
    	$wpdb->query("INSERT INTO " . $tabela . " (nome, url, target, icone) VALUES ('" . $ff[0] . "','" . $ff[1] . "','_blank', '". $ff[2] . "')");
	}
	
	add_option('umb_autojquery', 'true', '', 'yes');
	add_option('umb_txtexibicao', 'UmbigoThis!', '', 'yes');
}

function umb_uninstall(){
	global $wpdb;

	$tabela = $wpdb->prefix."umbigothis";

    $wpdb->query("DROP TABLE $tabela");
}

function umb_menu(){
	add_menu_page('UmbigoThis', 'UmbigoThis', 8, __FILE__, 'umb_painel');
}

function umb_painel(){
	
	if (isset($_POST['url_add']) ) {
		$nome = $_POST['nome_site'];
		$site = $_POST['url_site'];
		$target = $_POST['target_site'];
		$icone = $_POST['imagem_site'];
		if(umb_addurl($site, $nome, $target, $icone)):
			echo "<div class='updated'><p><strong>Site adicionado</strong></p></div>";
		else:
			echo "<div class='updated'><p>URL ou Nome do site em branco</p></div>";
		endif;
	};
	
	if (isset($_POST['opts_salvar']) ) {
		if (isset($_POST['box_jquery'])) :
			update_option('umb_autojquery', 'true');
		else:
			update_option('umb_autojquery', 'false');
		endif;
		update_option('umb_txtexibicao', $_POST['opts_texto']);
		echo "<div class='updated'><p><b>Salvo</b></p></div>";
	}
	
	if (isset($_POST['url_del_conf']) ) {
		echo umb_del($_POST['url_cid']);
	};

	if ( isset($_POST['url_del']) ) :
		$id = $_POST['url_id'];
		$nm = umb_search($id);
		echo "<div class='updated'><p>Você tem certeza que deseja remover o site <b>{$nm[0]}</b> (URL: <b>{$nm[1]}</b>) ?</p>
	<p><form method='post'>
		<input type='hidden' name='url_cid' value='{$id}'/>
		<input type='submit' value='Remover' name='url_del_conf' class='button'/>
		<input type='submit' value='Cancelar' name='' class='button'/>
	</form></p>
</div>";
	else:
?>
<div style="padding:0 15px 15px 15px;">
<h2>UmbigoThis</h2>
<p>Nesta página você poderá editar as opções do plugin UmbigoThis</p>
<p><form method="post">
	<?php if (get_option('umb_autojquery') == 'true'): $check = 'checked'; else: $check = ''; endif; ?>
	<input type="checkbox" name="box_jquery" id="box_jquery" <?php echo $check;?>/>Chamar jQuery<br/>
	<small>Desmarque caso você já use jQuery no seu Wordpress</small><br/><br/>
	<label for="opts_texto">Texto de exibição:</label>
	<input type="text" name="opts_texto" id="opts_texto" size="25" value="<?php echo get_option('umb_txtexibicao');?>" /><br/>
	<small>Exemplo: "Compartilhe", "Social Bookmarks"...</small><br/><br/>
	<input type="submit" value="Salvar" name="opts_salvar" class="button"/>
</form></p>
    <table class="form-table">
    	<thead>
    		<tr>
    			<th scope="col">ID</th>
    			<th scope="col">Site</th>
    			<th scope="col">Url</th>
    			<th scope="col">Ícone</th>
    			<th scope="col"></th>
    		</tr>
    	</thead>
    	<tbody>
<?php
    	$res = umb_get();
    	if (!empty($res)):
    		foreach ($res as $rst) {
?>
    		<tr>
    			<td><?php echo $rst->id;?></td>
    			<td><?php echo $rst->nome;?></td>
    			<td><?php echo $rst->url;?></td>
    			<td><?php echo $rst->icone;?></td>
    			<td>
    				<form method="post">
    					<input type="hidden" name="url_id" value="<?php echo $rst->id;?>"/>
    					<input type="submit" value="Remover" name="url_del" class="button"/>
    				</form>
    			</td>
    		</tr>
<?php
			}
			?>
    	</tbody>
    </table>
    <?php
    else:
    ?>
    	</tbody>
    </table>
    <p style="text-align:center;"><b>Nenhum site cadastrado</b></p>
    <?php    
    endif; ?>
<form method="post">
<p><b>Adicionar url:</b></p>
	<table class="form-table">
		<tbody>
			<tr>
				<th><label for="nome_site">Nome</label></th>
				<td><input type="text" name="nome_site" id="nome_site" size="40" value="" /></td>
			</tr>
			<tr>
				<th><label for="url_site">Url</label></th>
				<td>
					<input type="text" name="url_site" id="url_site" size="40" value="" />
					<br/>
					<small>Tags: Url - <b>{url}</b> | Título - <b>{title}</b></small><br/>
					<small>Exemplo: http://dihitt.com.br/submit.php?url=<b>{url}</b>&titulo=<b>{title}</b></small>
				</td>
			</tr>
			<tr>
				<th><label for="imagem_site">Ícone</label></th>
				<td>
					<input type="text" name="imagem_site" id="imagem_site" size="40" value="padrao.png" />
					<br/>
					<small>Todos os ícones devem estar na pasta <em>icones</em> dentro do diretório deste plugin</small>
				</td>
			</tr>
			<tr>
				<th><label for="target_site">Target</label></th>
				<td>
					<input type="text" name="target_site" id="target_site" size="40" value="_blank" />
				</td>
			</tr>
			<tr>
				<td></td>
				<td>
					<input type="submit" value="Adicionar" name="url_add" class="button"/>
					<input type="reset" value="Limpar" name="url_limpa" class="button"/>
				</td>
			</tr>
		</tbody>
	</table>
</form>
</div>
<?php
	endif;
}
?>
